#include<iostream.h>	// pour cin et cout
#include<time.h> 		// pour randomize
#include<stdlib.h>     	// pour random et randomize
#include<dos.h>		// pour sleep(nb_secondes)
#include<conio.h>	      // pour le getch()
struct carte {
	char couleur;	// 'c'=coeur, 'k'=carreau, 't'=trefle, 'p'=pique
	int  valeur;	// 1,2, ... nb_cartes_par_couleur
	};

				//pour les piles
#define type_struct
#define affiche_elem affiche_carte
void affiche_carte(carte une_carte);
typedef carte type_elt;
#include "pile.h"

				// pour les files
typedef carte f_elt;
#include "file.h"

/////////////////////////////////////////////////////////////////////
// prototype des fonctions
/////////////////////////////////////////////////////////////////////

						// pour une carte donnee,
						// affiche sa couleur et sa valeur
void affiche_carte(carte une_carte);

						// affiche une par une les cartes du jeu
void affiche_jeu(carte jeu[52]);

						// affiche les cartes d'une main
						// en commencant par le debut
void affiche_main(file main);

						// pour une carte donnee,
						//renvoie une entier donnant sa hauteur
						// pour pouvoir comparer 2 cartes, on a :
						// '2' < '3' < ... < '9' < 'X' < 'V'
						//				< 'D' < 'R' < '1'
int hauteur(carte une_carte);

						// initialise un vecteur de 52 cartes
						// avec 4 couleur x 13 valeur
void construire_jeu(carte jeu[]);

						// melange aleatoirement un jeu de 52 cartes
void melanger(carte jeu[]);

						// distribue une par une et
						// alternativement les cartes du jeu
						// a main_1 et a main_2
void distribuer(carte jeu[], file & main_1, file & main_2);

						// affiche une phase de jeu, c-a-d :
						// nb de cartes ds la main du joueur 1,
						// carte sur le sommet du tas du joueur 1,
						// nb de cartes dans les tas,
						// carte sur le sommet du tas du joueur 2,
						// nb de cartes ds la main du joueur 2,
void affiche_phase_jeu(int nb_main_1, carte sommet_tas_1, int nb_tas,
				carte sommet_tas_2, int nb_main_2);

						// affiche le gagnant
void afficher_gagnant(file main_1, file main_2);

//////////////////////// constantes globales ///////////////////////////

const int nb_couleurs = 4;  		// forcement
const int nb_cartes_par_couleur = 13;
const int nb_cartes_jeu = nb_couleurs * nb_cartes_par_couleur;

///////////////////// programme principal /////////////////////////////////

void main (void){
char c;
int nb_main_1 = nb_cartes_jeu /2, nb_main_2 = nb_cartes_jeu / 2;
int nb_tas=0;
int gagnant;
int carte_a_l_envers = 0;		// vaut 1 lorsqu'on doit poser
						// les cartes a l'envers (bataille)
carte une_carte;
carte jeu[nb_cartes_jeu];
file main_1,main_2;
pile tas_1,tas_2;

init_file(main_1);
init_file(main_2);

init_pile(tas_1);
init_pile(tas_2);

clrscr();
construire_jeu(jeu);
affiche_jeu(jeu); getch();

melanger(jeu);
affiche_jeu(jeu); getch();

distribuer(jeu, main_1,main_2);
cout << endl<< "main du joueur 1"<<endl;
affiche_main(main_1);
cout << endl<< "main du joueur 2"<<endl;
affiche_main(main_2);

cout << "------------- D E R O U L E M E N T    D U   J E U  --------------";
cout << endl << endl;
cout << "main 1    carte tas 1         tas       ";
cout << " carte tas 2          main 2" << endl << endl;


while( (!file_vide(main_1)) && (!file_vide(main_2)))
	{
						// afficher etat des mains et du tas
	if (!carte_a_l_envers)
		{
		cout <<nb_main_1 <<"                              " << nb_tas;
		cout <<"                              "<<nb_main_2<<endl;
		c = getch();
		}
						// le joueur 1 met sa carte
	supprimer(une_carte,main_1);nb_main_1--;
	empiler(tas_1,une_carte);nb_tas++;

						// le joueur 2 met sa carte
	supprimer(une_carte,main_2);nb_main_2--;
	empiler(tas_2,une_carte);

	if (carte_a_l_envers)
		{
		carte_a_l_envers = 0;	// au prochain coup : carte a l'endroit
		}
	else                          // si carte a l'endroit
		{
						// afficher les cartes posees
						// et l'etat des mains et du tas
		affiche_phase_jeu(nb_main_1, sommet(tas_1), nb_tas,
					sommet(tas_2), nb_main_2);
		c = getch();
						// determiner qui gagne
						// et rammasser si pas bataille
						// si egalite
		if (hauteur(sommet(tas_1)) == hauteur(sommet(tas_2)))
			carte_a_l_envers = 1;

		else if (hauteur(sommet(tas_1)) > hauteur(sommet(tas_2)))
			{
						// le joueur 1 rammasse le tas 1
			while(!pile_vide(tas_1))
				{
				depiler(tas_1,une_carte);nb_tas--;
				ajouter(une_carte,main_1);nb_main_1++;
				}
						// le joueur 1 rammasse le tas 2
			while(!pile_vide(tas_2))
				{
				depiler(tas_2,une_carte);
				ajouter(une_carte,main_1);nb_main_1++;
				}
			}
		else				// le gagnant est le joueur 2
			{
						// le joueur 2 rammasse le tas 2
			while(!pile_vide(tas_2))
				{
				depiler(tas_2,une_carte);nb_tas--;
				ajouter(une_carte,main_2);nb_main_2++;
				}

						// le joueur 2 rammasse le tas 1
			while(!pile_vide(tas_1))
				{
				depiler(tas_1,une_carte);
				ajouter(une_carte,main_2);nb_main_2++;
				}
			}
		}
	if (c=='b') break;
	} 					// fin du while
afficher_gagnant(main_1, main_2);	// affiche le gagnant
getch();
}

////////////////////// definition des fonctions /////////////////////////

///////////////////////////// affiche_carte /////////////////////////////
// affiche la couleur et la valeur d'une carte

void affiche_carte(carte une_carte)
{
cout << " " ;

if ((2 <= une_carte.valeur) && (une_carte.valeur <= 9))
	cout << "    " << une_carte.valeur;
else
	switch (une_carte.valeur)
	{
	case 1 : cout << "   As"; break;
	case 10: cout << "   10"; break;
	case 11: cout << "Valet"; break;
	case 12: cout << " Dame"; break;
	case 13: cout << "  Roi"; break;
	}
cout << " de ";
switch (une_carte.couleur)
	{
	case 'c': cout << "coeur   ";
		  break;
	case 'k': cout << "carreau ";
		  break;
	case 't': cout << "trefle  ";
		  break;
	case 'p': cout << "pique   ";
		  break;
	}
}

////////////////////////////// hauteur ////////////////////////////////
// pour une carte donnee, renvoie une entier correspondant a sa hauteur
// afin de pouvoir comparer deux cartes, on a :
// 2 < 3 < ... < 9 < 10 < valet < dame < roi < as

int hauteur(carte une_carte){
if (une_carte.valeur == 1)
	return 14;
else
	return(une_carte.valeur);
}

/////////////////////////////// affiche_jeu ////////////////////////////
// affiche une par une les cartes du jeu

void affiche_jeu(carte jeu[])
{
int i;
cout << endl << endl;
for(i=0; i<nb_cartes_jeu; i++)
	{
	affiche_carte(jeu[i]);
	cout << "   ";
	if (!((i+1)%3)) cout << endl;
	}
cout << endl << endl;
}

///////////////// affiche les cartes d'une main /////////////////////////
void affiche_main(file main)
{
f_cellule * aux;
int cpt=1;
aux=main.first;
cout << endl;
while (aux!=NULL)
	{
	affiche_carte(aux->info);
	aux=aux->suiv;
	if(!(cpt%3)) cout << endl;
	cpt++;
	}
cout << endl;
}

/////////////////////////// construire_jeu /////////////////////////////
// initialise un vecteur de cartes avec nb_couleurs couleurs
// et nb_cartes_par_couleur valeurs

void construire_jeu(carte jeu[])
{
int i,j,nbc;
cout << "construction du jeu";
							// les couleurs
nbc = nb_cartes_par_couleur;
for(i=0;     i < nbc; i++) jeu[i].couleur='p';
for(i=nbc;   i < 2*nbc; i++) jeu[i].couleur='c';
for(i=2*nbc; i < 3*nbc; i++) jeu[i].couleur='k';
for(i=3*nbc; i < 4*nbc; i++) jeu[i].couleur='t';

							// les valeurs
for(i=0; i<nb_couleurs; i++)
	{
	for(j=0; j < nb_cartes_par_couleur; j++)
		jeu[(i*nbc)+j].valeur = j+1;
	}
}

///////////////////////////// melanger /////////////////////////////////
// melange aleatoirement un jeu de 52 cartes

void melanger(carte jeu[])
{
int i,rd;
carte aux;
randomize();
cout << "melange du jeu";
for(i=0;i<nb_cartes_jeu;i++)		// on parcourt le jeu, pour chaque indice
	{			// on echange la carte situee a cet indice
	rd=random(nb_cartes_jeu);		// avec une carte dont l'indice est obtenu
	aux=jeu[i];		// aleatoirement
	jeu[i]=jeu[rd];
	jeu[rd]=aux;
	}
}

////////////////////////////////// distribuer ///////////////////////////
// distribue une par une et alternativement les cartes d'un jeu
// a main_1 et a main_2

void distribuer(carte jeu[], file & main_1, file & main_2)
{
int i;
cout << "distribution du jeu"<<endl;
for(i=0; i<nb_cartes_jeu; i=i+2)
	{
	ajouter(jeu[i],main_1);
	ajouter(jeu[i+1],main_2);
	}
}

///////////////////////////////// affiche_phase_jeu ///////////////////////
// affiche les donnees concernant chaque phase de jeu, c-a-d :
//    le nombre de cartes dans la main du joueur 1,
// 	la carte sur le sommet du tas du joueur 1,
// 	le nombre de cartes dans les tas,
// 	la carte sur le sommet du tas du joueur 2,
// 	le nombre de cartes dans la main du joueur 2,

void affiche_phase_jeu(int nb_main_1, carte sommet_tas_1, int nb_tas,
				carte sommet_tas_2, int nb_main_2)
{
cout<< nb_main_1 << "      ";
affiche_carte(sommet_tas_1);
cout <<"      "<< nb_tas<<"      ";
affiche_carte(sommet_tas_2);
cout<< "      "<<nb_main_2 << endl;
}

///////////////////// afficher_gagnant //////////////////////////////

void afficher_gagnant(file main_1, file main_2)
{
cout << endl << endl;
cout << "		";
if (file_vide(main_1) && !(file_vide(main_2)))
	cout << "le joueur 2 a gagne";
else if (!file_vide(main_1))
	cout << "le joueur 1 a gagne";
else						// cas improbable de la bataille geante
						// ou tout le jeu est dans les tas!
	cout << "jeu bloque !!!";
}



